trait Stream[A] {

  def hasElement ():Boolean
  def head ():A
  def tail ():Stream[A]

}


//
// Useful functions on streams
//

object Stream {

  def print[A] (st:Stream[A]):Unit = 
    if (st.hasElement()) {
      println("  " + st.head());
      print(st.tail())
    } else
      ()

  def sumInt (st:Stream[Int]):Int = 
    if (st.hasElement())
      st.head() + sumInt(st.tail())
    else
      0

  def sumPairInt (st:Stream[PairInt]):PairInt = 
    if (st.hasElement())
      st.head().add(sumPairInt(st.tail()))
    else
      PairInt.create(0,0)

  def sum[T <: Addable[T]] (u:T,st:Stream[T]):T = 
    if (st.hasElement())
      st.head().add(sum(u,st.tail()))
    else 
      u
}

